/*
 * Work under Copyright. Licensed under the EUPL.
 * See the project README.md and LICENSE.txt for more information.
 */

package net.dries007.tfc.client.model.animal;

import javax.annotation.ParametersAreNonnullByDefault;

import net.minecraft.client.model.ModelQuadruped;
import net.minecraft.client.model.ModelRenderer;
import net.minecraft.client.renderer.GlStateManager;
import net.minecraft.entity.Entity;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

import net.dries007.tfc.objects.entity.animal.EntitySheepTFC;

@SideOnly(Side.CLIENT)
@ParametersAreNonnullByDefault
public class ModelSheepWoolTFC extends ModelQuadruped
{
    public ModelSheepWoolTFC()
    {
        super(12, 0.0F);
        this.field_78150_a = new ModelRenderer(this, 0, 0);
        this.field_78150_a.func_78790_a(-3.0F, -4.0F, -4.0F, 6, 6, 6, 0.6F);
        this.field_78150_a.func_78793_a(0.0F, 6.0F, -8.0F);
        this.field_78148_b = new ModelRenderer(this, 28, 8);
        this.field_78148_b.func_78790_a(-4.0F, -10.0F, -7.0F, 8, 16, 6, 1.75F);
        this.field_78148_b.func_78793_a(0.0F, 5.0F, 2.0F);
        this.field_78149_c = new ModelRenderer(this, 0, 16);
        this.field_78149_c.func_78790_a(-2.0F, 0.0F, -2.0F, 4, 6, 4, 0.5F);
        this.field_78149_c.func_78793_a(-3.0F, 12.0F, 7.0F);
        this.field_78146_d = new ModelRenderer(this, 0, 16);
        this.field_78146_d.func_78790_a(-2.0F, 0.0F, -2.0F, 4, 6, 4, 0.5F);
        this.field_78146_d.func_78793_a(3.0F, 12.0F, 7.0F);
        this.field_78147_e = new ModelRenderer(this, 0, 16);
        this.field_78147_e.func_78790_a(-2.0F, 0.0F, -2.0F, 4, 6, 4, 0.5F);
        this.field_78147_e.func_78793_a(-3.0F, 12.0F, -5.0F);
        this.field_78144_f = new ModelRenderer(this, 0, 16);
        this.field_78144_f.func_78790_a(-2.0F, 0.0F, -2.0F, 4, 6, 4, 0.5F);
        this.field_78144_f.func_78793_a(3.0F, 12.0F, -5.0F);
    }

    @Override
    public void func_78088_a(Entity entity, float par2, float par3, float par4, float par5, float par6, float par7)
    {
        this.func_78087_a(par2, par3, par4, par5, par6, par7, entity);
        EntitySheepTFC sheep = ((EntitySheepTFC) entity);

        float percent = sheep.getPercentToAdulthood();
        float ageScale = 2.0F - percent;
        float ageHeadScale = (float) Math.pow(1 / ageScale, 0.66);

        GlStateManager.func_179094_E();

        GlStateManager.func_179109_b(0.0F, 0.75f - (0.75f * percent), 0f);
        GlStateManager.func_179152_a(ageHeadScale, ageHeadScale, ageHeadScale);
        GlStateManager.func_179109_b(0.0F, (ageScale - 1) * -0.125f, 0.1875f - (0.1875f * percent));


        this.field_78150_a.func_78785_a(par7);

        GlStateManager.func_179121_F();
        GlStateManager.func_179094_E();
        GlStateManager.func_179109_b(0.0F, 0.75f - (0.75f * percent), 0f);
        GlStateManager.func_179152_a(1 / ageScale, 1 / ageScale, 1 / ageScale);
        this.field_78148_b.func_78785_a(par7);
        this.field_78149_c.func_78785_a(par7);
        this.field_78146_d.func_78785_a(par7);
        this.field_78147_e.func_78785_a(par7);
        this.field_78144_f.func_78785_a(par7);
        GlStateManager.func_179121_F();
    }
}
