/*
 * Work under Copyright. Licensed under the EUPL.
 * See the project README.md and LICENSE.txt for more information.
 */

package net.dries007.tfc.client.render;

import net.minecraft.client.Minecraft;
import net.minecraft.client.renderer.GlStateManager;
import net.minecraft.client.renderer.RenderHelper;
import net.minecraft.client.renderer.RenderItem;
import net.minecraft.client.renderer.block.model.ItemCameraTransforms;
import net.minecraft.client.renderer.tileentity.TileEntitySpecialRenderer;
import net.minecraft.item.ItemStack;
import net.minecraft.world.World;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;
import net.minecraftforge.items.CapabilityItemHandler;
import net.minecraftforge.items.IItemHandler;

import net.dries007.tfc.objects.te.TEPlacedItem;

@SideOnly(Side.CLIENT)
public class TESRPlacedItem extends TileEntitySpecialRenderer<TEPlacedItem>
{
    @Override
    public void func_192841_a(TEPlacedItem te, double x, double y, double z, float partialTicks, int destroyStage, float alpha)
    {
        RenderItem renderItem = Minecraft.func_71410_x().func_175599_af();
        World world = te.func_145831_w();
        //noinspection ConstantConditions
        if (world == null) return;

        GlStateManager.func_179094_E();
        GlStateManager.func_179123_a();
        GlStateManager.func_179140_f();
        GlStateManager.func_179137_b(x, y, z);

        GlStateManager.func_179094_E();
        IItemHandler cap = te.getCapability(CapabilityItemHandler.ITEM_HANDLER_CAPABILITY, null);
        if (cap != null)
        {
            float timeD = (float) (360.0 * (System.currentTimeMillis() & 0x3FFFL) / 0x3FFFL);
            GlStateManager.func_179137_b(0.25, 0.25, 0.25);
            RenderHelper.func_74519_b();
            GlStateManager.func_179123_a();

            if (te.holdingLargeItem())
            {
                ItemStack stack = cap.getStackInSlot(0);
                if (!stack.func_190926_b())
                {
                    GlStateManager.func_179094_E();
                    GlStateManager.func_179137_b(0.25, 0, 0.25);
                    GlStateManager.func_179114_b(timeD, 0, 1, 0);
                    renderItem.func_181564_a(stack, ItemCameraTransforms.TransformType.FIXED);
                    GlStateManager.func_179121_F();
                }
            }
            else
            {
                GlStateManager.func_179152_a(0.5F, 0.5F, 0.5F);
                for (int i = 0; i < cap.getSlots(); i++)
                {
                    ItemStack stack = cap.getStackInSlot(i);
                    if (stack.func_190926_b()) continue;
                    GlStateManager.func_179094_E();
                    GlStateManager.func_179109_b((i % 2 == 0 ? 1 : 0), 0, (i < 2 ? 1 : 0));
                    GlStateManager.func_179114_b(timeD, 0, 1, 0);
                    renderItem.func_181564_a(stack, ItemCameraTransforms.TransformType.FIXED);
                    GlStateManager.func_179121_F();
                }
            }

            RenderHelper.func_74518_a();
            GlStateManager.func_179099_b();
            GlStateManager.func_179121_F();


            GlStateManager.func_179099_b();
            GlStateManager.func_179121_F();
        }
    }
}
