/*
 * Work under Copyright. Licensed under the EUPL.
 * See the project README.md and LICENSE.txt for more information.
 */

package net.dries007.tfc.client.render;

import org.lwjgl.opengl.GL11;
import net.minecraft.client.Minecraft;
import net.minecraft.client.renderer.GlStateManager;
import net.minecraft.client.renderer.RenderHelper;
import net.minecraft.client.renderer.block.model.IBakedModel;
import net.minecraft.client.renderer.block.model.ItemCameraTransforms;
import net.minecraft.client.renderer.texture.TextureMap;
import net.minecraft.client.renderer.tileentity.TileEntitySpecialRenderer;
import net.minecraft.item.ItemStack;
import net.minecraftforge.client.ForgeHooksClient;
import net.minecraftforge.items.CapabilityItemHandler;
import net.minecraftforge.items.IItemHandler;

import net.dries007.tfc.objects.te.TEQuern;

public class TESRQuern extends TileEntitySpecialRenderer<TEQuern>
{
    @Override
    public void func_192841_a(TEQuern te, double x, double y, double z, float partialTicks, int destroyStage, float alpha)
    {
        super.func_192841_a(te, x, y, z, partialTicks, destroyStage, alpha);

        IItemHandler cap = te.getCapability(CapabilityItemHandler.ITEM_HANDLER_CAPABILITY, null);
        if (cap != null)
        {
            ItemStack input = cap.getStackInSlot(TEQuern.SLOT_INPUT);
            ItemStack output = cap.getStackInSlot(TEQuern.SLOT_OUTPUT);
            ItemStack handstone = cap.getStackInSlot(TEQuern.SLOT_HANDSTONE);

            if (!output.func_190926_b())
            {
                for (int i = 0; i < output.func_190916_E(); i++)
                {
                    double yPos = y + 0.625;
                    GlStateManager.func_179091_B();
                    GlStateManager.func_179092_a(GL11.GL_GREATER, 0.1f);
                    GlStateManager.func_179147_l();
                    RenderHelper.func_74519_b();
                    GlStateManager.func_179120_a(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA, 1, 0);
                    GlStateManager.func_179094_E();

                    switch (Math.floorDiv(i, 16))
                    {
                        case 0:
                        {
                            GlStateManager.func_179137_b(x + 0.125, yPos, z + 0.125 + (0.046875 * i));
                            GlStateManager.func_179114_b(75, 1, 0, 0);
                            break;
                        }
                        case 1:
                        {
                            GlStateManager.func_179137_b(x + 0.125 + (0.046875 * (i - 16)), yPos, z + 0.875);
                            GlStateManager.func_179114_b(90, 0, 1, 0);
                            GlStateManager.func_179114_b(75, 1, 0, 0);
                            break;
                        }
                        case 2:
                        {
                            GlStateManager.func_179137_b(x + 0.875, yPos, z + 0.875 - (0.046875 * (i - 32)));
                            GlStateManager.func_179114_b(180, 0, 1, 0);
                            GlStateManager.func_179114_b(75, 1, 0, 0);
                            break;
                        }
                        case 3:
                        {
                            GlStateManager.func_179137_b(x + 0.875 - (0.046875 * (i - 48)), yPos, z + 0.125);
                            GlStateManager.func_179114_b(270, 0, 1, 0);
                            GlStateManager.func_179114_b(75, 1, 0, 0);
                            break;
                        }
                        default:
                        {
                            GlStateManager.func_179137_b(x + 0.5, y + 1.0, z + 0.5);
                            GlStateManager.func_179114_b((te.func_145831_w().func_82737_E() + partialTicks) * 4, 0, 1, 0);
                        }
                    }

                    GlStateManager.func_179139_a(0.125, 0.125, 0.125);

                    IBakedModel outputModel = Minecraft.func_71410_x().func_175599_af().func_184393_a(output, te.func_145831_w(), null);
                    outputModel = ForgeHooksClient.handleCameraTransforms(outputModel, ItemCameraTransforms.TransformType.FIXED, false);

                    Minecraft.func_71410_x().func_110434_K().func_110577_a(TextureMap.field_110575_b);
                    Minecraft.func_71410_x().func_175599_af().func_180454_a(output, outputModel);

                    GlStateManager.func_179121_F();
                    GlStateManager.func_179101_C();
                    GlStateManager.func_179084_k();
                }
            }

            if (!handstone.func_190926_b())
            {
                int rotationTicks = te.getRotationTimer();
                double center = (rotationTicks > 0) ? 0.497 + (te.func_145831_w().field_73012_v.nextDouble() * 0.006) : 0.5;

                GlStateManager.func_179091_B();
                GlStateManager.func_179092_a(GL11.GL_GREATER, 0.1f);
                GlStateManager.func_179147_l();
                RenderHelper.func_74519_b();
                GlStateManager.func_179120_a(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA, 1, 0);
                GlStateManager.func_179094_E();
                GlStateManager.func_179137_b(x + center, y + 0.75, z + center);

                if (rotationTicks > 0)
                {
                    GlStateManager.func_179114_b((rotationTicks - partialTicks) * 4, 0, 1, 0);
                }

                IBakedModel handstoneModel = Minecraft.func_71410_x().func_175599_af().func_184393_a(handstone, te.func_145831_w(), null);
                handstoneModel = ForgeHooksClient.handleCameraTransforms(handstoneModel, ItemCameraTransforms.TransformType.FIXED, false);

                GlStateManager.func_179139_a(1.25, 1.25, 1.25);
                Minecraft.func_71410_x().func_110434_K().func_110577_a(TextureMap.field_110575_b);
                Minecraft.func_71410_x().func_175599_af().func_180454_a(handstone, handstoneModel);

                GlStateManager.func_179121_F();
                GlStateManager.func_179101_C();
                GlStateManager.func_179084_k();
            }

            if (!input.func_190926_b())
            {
                double height = (handstone.func_190926_b()) ? 0.75 : 0.875;
                GlStateManager.func_179091_B();
                GlStateManager.func_179092_a(GL11.GL_GREATER, 0.1f);
                GlStateManager.func_179147_l();
                RenderHelper.func_74519_b();
                GlStateManager.func_179120_a(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA, 1, 0);
                GlStateManager.func_179094_E();
                GlStateManager.func_179137_b(x + 0.5, y + height, z + 0.5);
                GlStateManager.func_179114_b(45, 0, 1, 0);
                GlStateManager.func_179139_a(0.5, 0.5, 0.5);

                IBakedModel inputModel = Minecraft.func_71410_x().func_175599_af().func_184393_a(input, te.func_145831_w(), null);
                inputModel = ForgeHooksClient.handleCameraTransforms(inputModel, ItemCameraTransforms.TransformType.GROUND, false);

                Minecraft.func_71410_x().func_110434_K().func_110577_a(TextureMap.field_110575_b);
                Minecraft.func_71410_x().func_175599_af().func_180454_a(input, inputModel);

                GlStateManager.func_179121_F();
                GlStateManager.func_179101_C();
                GlStateManager.func_179084_k();
            }
        }
    }
}
