/*
 * Work under Copyright. Licensed under the EUPL.
 * See the project README.md and LICENSE.txt for more information.
 */

package net.dries007.tfc.network;

import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.ItemStack;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.math.BlockPos;
import net.minecraft.util.math.RayTraceResult;
import net.minecraft.world.World;
import net.minecraftforge.fml.common.network.simpleimpl.IMessage;
import net.minecraftforge.fml.common.network.simpleimpl.IMessageHandler;
import net.minecraftforge.fml.common.network.simpleimpl.MessageContext;

import net.dries007.tfc.TerraFirmaCraft;
import net.dries007.tfc.objects.blocks.BlocksTFC;
import net.dries007.tfc.objects.te.TEPlacedItem;
import net.dries007.tfc.util.Helpers;

/**
 * This packet is send when the client player presses the "Place Block Special" keybind. It has no special information
 */
public class PacketPlaceBlockSpecial implements IMessageEmpty
{
    public static final class Handler implements IMessageHandler<PacketPlaceBlockSpecial, IMessage>
    {
        @Override
        public IMessage onMessage(PacketPlaceBlockSpecial message, MessageContext ctx)
        {
            final EntityPlayer player = TerraFirmaCraft.getProxy().getPlayer(ctx);
            if (player != null)
            {
                TerraFirmaCraft.getProxy().getThreadListener(ctx).func_152344_a(() -> {

                    final World world = player.func_130014_f_();
                    final RayTraceResult rayTrace = Helpers.rayTrace(player, player.func_110148_a(EntityPlayer.REACH_DISTANCE).func_111126_e(), 1);
                    final ItemStack stack = player.func_184614_ca().func_190926_b() ? player.func_184592_cb() : player.func_184614_ca();

                    if (rayTrace != null)
                    {
                        BlockPos pos = rayTrace.func_178782_a();
                        EnumFacing hitFace = rayTrace.field_178784_b;
                        double placeReach = player.func_110148_a(EntityPlayer.REACH_DISTANCE).func_111126_e();
                        if (player.func_174818_b(pos) <= placeReach * placeReach && hitFace != null)
                        {
                            if (!stack.func_190926_b() && world.func_180495_p(pos).func_185915_l() && world.func_180495_p(pos.func_177972_a(hitFace)).func_177230_c().func_176200_f(world, pos))
                            {
                                world.func_175656_a(pos.func_177984_a(), BlocksTFC.PLACED_ITEM.func_176223_P());
                                TEPlacedItem tile = Helpers.getTE(world, pos.func_177984_a(), TEPlacedItem.class);
                                if (tile != null)
                                {
                                    tile.onRightClick(player, stack, rayTrace);
                                }
                            }
                            else if (world.func_180495_p(pos).func_177230_c() == BlocksTFC.PLACED_ITEM)
                            {
                                TEPlacedItem tile = Helpers.getTE(world, pos, TEPlacedItem.class);
                                if (tile != null)
                                {
                                    tile.onRightClick(player, stack, rayTrace);
                                }
                            }
                            else if (world.func_180495_p(pos.func_177972_a(hitFace)).func_177230_c() == BlocksTFC.PLACED_ITEM)
                            {
                                TEPlacedItem tile = Helpers.getTE(world, pos.func_177972_a(hitFace), TEPlacedItem.class);
                                if (tile != null)
                                {
                                    tile.onRightClick(player, stack, rayTrace);
                                }
                            }
                        }
                    }
                });
            }
            return null;
        }
    }
}

