/*
 * Work under Copyright. Licensed under the EUPL.
 * See the project README.md and LICENSE.txt for more information.
 */

package net.dries007.tfc.objects.container;

import javax.annotation.Nullable;

import net.minecraft.block.state.IBlockState;
import net.minecraft.entity.player.InventoryPlayer;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraftforge.items.CapabilityItemHandler;
import net.minecraftforge.items.IItemHandler;

import net.dries007.tfc.objects.inventory.slot.SlotCallback;
import net.dries007.tfc.objects.te.TELargeVessel;

import static net.dries007.tfc.objects.blocks.wood.BlockBarrel.SEALED;

public class ContainerLargeVessel extends ContainerTE<TELargeVessel> implements IButtonHandler
{

    public ContainerLargeVessel(InventoryPlayer playerInv, TELargeVessel tile)
    {
        super(playerInv, tile, true);
    }

    @Override
    public void onButtonPress(int buttonID, @Nullable NBTTagCompound extraNBT)
    {
        // Slot will always be 0, extraNBT will be empty
        if (!tile.func_145831_w().field_72995_K)
        {
            IBlockState state = tile.func_145831_w().func_180495_p(tile.func_174877_v());

            if (state.func_177229_b(SEALED))
            {
                tile.onUnseal();
            }
            else
            {
                tile.onSeal();
            }

            tile.func_145831_w().func_175656_a(tile.func_174877_v(), state.func_177226_a(SEALED, !state.func_177229_b(SEALED)));
            tile.onSealed();
        }
    }

    @Override
    protected void addContainerSlots()
    {
        IItemHandler inventory = tile.getCapability(CapabilityItemHandler.ITEM_HANDLER_CAPABILITY, null);

        if (inventory != null)
        {
            for (int y = 0; y < 3; y++)
            {
                for (int x = 0; x < 3; x++)
                {
                    func_75146_a(new SlotCallback(inventory, x * 3 + y, 34 + x * 18, 19 + y * 18, tile));
                }
            }
        }
    }
}
