/*
 * Work under Copyright. Licensed under the EUPL.
 * See the project README.md and LICENSE.txt for more information.
 */

package net.dries007.tfc.objects.entity;

import javax.annotation.ParametersAreNonnullByDefault;

import net.minecraft.entity.Entity;
import net.minecraft.entity.EntityLiving;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.World;

import mcp.MethodsReturnNonnullByDefault;

/**
 * Generic entity used for sitting on top of blocks
 */
@ParametersAreNonnullByDefault
@MethodsReturnNonnullByDefault
public class EntitySeatOn extends Entity
{
    private BlockPos pos;

    public EntitySeatOn(World world)
    {
        super(world);
        this.field_70145_X = true;
        this.field_70131_O = 0.01F;
        this.field_70130_N = 0.01F;
    }

    public EntitySeatOn(World world, BlockPos pos, double y0ffset)
    {
        this(world);
        this.pos = pos;
        func_70107_b(pos.func_177958_n() + 0.5D, pos.func_177956_o() + y0ffset, pos.func_177952_p() + 0.5D);
    }

    public BlockPos getPos()
    {
        return this.pos;
    }

    public Entity getSittingEntity()
    {
        for (Entity ent : this.func_184188_bt())
        {
            if (ent instanceof EntityLiving) return ent;
        }
        return null;
    }

    @Override
    protected void func_70088_a()
    {
    }

    @Override
    public void func_70030_z()
    {
        if (!this.field_70170_p.field_72995_K)
        {
            if (pos == null || !this.func_184207_aI() || this.field_70170_p.func_175623_d(pos))
            {
                this.func_70106_y();
            }
        }
    }

    @Override
    protected boolean func_142008_O()
    {
        return false;
    }

    @Override
    protected void func_70037_a(NBTTagCompound compound)
    {
    }

    @Override
    protected void func_70014_b(NBTTagCompound compound)
    {
    }

    @Override
    public double func_70042_X()
    {
        return this.field_70131_O * 0.0D;
    }

}
