/*
 * Work under Copyright. Licensed under the EUPL.
 * See the project README.md and LICENSE.txt for more information.
 */

package net.dries007.tfc.objects.te;

import javax.annotation.ParametersAreNonnullByDefault;

import net.minecraft.entity.Entity;
import net.minecraft.init.Items;
import net.minecraft.item.ItemStack;
import net.minecraft.util.ITickable;

import net.dries007.tfc.api.capability.egg.CapabilityEgg;
import net.dries007.tfc.api.capability.egg.IEgg;
import net.dries007.tfc.objects.entity.animal.EntityAnimalOviparous;
import net.dries007.tfc.util.Helpers;
import net.dries007.tfc.util.calendar.CalendarTFC;

@ParametersAreNonnullByDefault
public class TENestBox extends TEInventory implements ITickable
{
    private static final int NUM_SLOTS = 4;

    public TENestBox()
    {
        super(NUM_SLOTS);
    }

    @Override
    public void func_73660_a()
    {
        if (!field_145850_b.field_72995_K)
        {
            for (int i = 0; i < inventory.getSlots(); i++)
            {
                ItemStack stack = inventory.getStackInSlot(i);
                if (!stack.func_190926_b())
                {
                    IEgg cap = stack.getCapability(CapabilityEgg.CAPABILITY, null);
                    if (cap != null && cap.getHatchDay() > 0 && cap.getHatchDay() <= CalendarTFC.PLAYER_TIME.getTotalDays())
                    {
                        Entity baby = cap.getEntity(this.field_145850_b);
                        if (baby != null)
                        {
                            if (baby instanceof EntityAnimalOviparous)
                            {
                                ((EntityAnimalOviparous) baby).setBirthDay((int) CalendarTFC.PLAYER_TIME.getTotalDays());
                            }
                            baby.func_70012_b(this.field_174879_c.func_177958_n(), this.field_174879_c.func_177956_o() + 0.5D, this.field_174879_c.func_177952_p(), 0.0F, 0.0F);
                            field_145850_b.func_72838_d(baby);
                            inventory.setStackInSlot(i, ItemStack.field_190927_a);
                        }
                    }
                }
            }
        }
    }

    @Override
    public int getSlotLimit(int slot)
    {
        return 1;
    }

    @Override
    public boolean isItemValid(int slot, ItemStack stack)
    {
        return stack.func_77973_b() == Items.field_151110_aK;
    }

    public void insertEgg(ItemStack stack)
    {
        for (int i = 0; i < inventory.getSlots(); i++)
        {
            if (inventory.insertItem(i, stack, false).func_190926_b())
            {
                return;
            }
        }
    }

    public boolean hasFreeSlot()
    {
        for (int i = 0; i < inventory.getSlots(); i++)
        {
            if (inventory.getStackInSlot(i).func_190926_b())
            {
                return true;
            }
        }
        return false;
    }

    public boolean hasBird()
    {
        return getBird() != null;
    }

    public void seatOnThis(EntityAnimalOviparous bird)
    {
        Helpers.sitOnBlock(this.field_145850_b, this.field_174879_c, bird, 0.0D);
    }

    public Entity getBird()
    {
        return Helpers.getSittingEntity(this.field_145850_b, this.field_174879_c);
    }
}
