/*
 * Work under Copyright. Licensed under the EUPL.
 * See the project README.md and LICENSE.txt for more information.
 */

package net.dries007.tfc.objects.te;

import javax.annotation.Nonnull;
import javax.annotation.ParametersAreNonnullByDefault;

import net.minecraft.nbt.NBTTagCompound;

import net.dries007.tfc.util.calendar.CalendarTFC;

@ParametersAreNonnullByDefault
public class TETickCounter extends TEBase
{
    private long lastUpdateTick;

    public long getTicksSinceUpdate()
    {
        return CalendarTFC.PLAYER_TIME.getTicks() - lastUpdateTick;
    }

    public void resetCounter()
    {
        lastUpdateTick = CalendarTFC.PLAYER_TIME.getTicks();
        func_70296_d();
    }

    @Override
    public void func_145839_a(NBTTagCompound nbt)
    {
        lastUpdateTick = nbt.func_74763_f("tick");
        super.func_145839_a(nbt);
    }

    @Nonnull
    @Override
    public NBTTagCompound func_189515_b(NBTTagCompound nbt)
    {
        nbt.func_74772_a("tick", lastUpdateTick);
        return super.func_189515_b(nbt);
    }
}
