/*
 * Work under Copyright. Licensed under the EUPL.
 * See the project README.md and LICENSE.txt for more information.
 */

package net.dries007.tfc.world.classic.biomes;

import javax.annotation.Nonnull;

import net.minecraft.world.biome.Biome;
import net.minecraft.world.biome.BiomeDecorator;

import net.dries007.tfc.objects.entity.animal.*;

import net.minecraft.world.biome.Biome.BiomeProperties;

public class BiomeTFC extends Biome
{
    public final int waterPlantsPerChunk;
    public final int lilyPadPerChunk;
    private boolean spawnBiome;

    public BiomeTFC(BiomeProperties properties)
    {
        this(properties, 0, 0);
    }

    public BiomeTFC(BiomeProperties properties, int lilyPadPerChunk, int waterPlantsPerChunk)
    {
        super(properties);
        this.lilyPadPerChunk = lilyPadPerChunk;
        this.waterPlantsPerChunk = waterPlantsPerChunk;

        // throw out the first decorator, because it's missing the lilypad & plant settings
        this.field_76760_I = func_76729_a();

        this.field_76762_K.clear();
        this.field_76762_K.add(new Biome.SpawnListEntry(EntitySheepTFC.class, 12, 4, 4));
        this.field_76762_K.add(new Biome.SpawnListEntry(EntityPigTFC.class, 10, 4, 4));
        this.field_76762_K.add(new Biome.SpawnListEntry(EntityChickenTFC.class, 10, 4, 4));
        this.field_76762_K.add(new Biome.SpawnListEntry(EntityCowTFC.class, 8, 4, 4));
        this.field_76762_K.add(new Biome.SpawnListEntry(EntityDeerTFC.class, 14, 2, 4));
        this.field_76762_K.add(new Biome.SpawnListEntry(EntityPheasantTFC.class, 14, 2, 4));
        this.field_76762_K.add(new Biome.SpawnListEntry(EntityBearTFC.class, 4, 1, 2));
        spawnBiome = false;
    }

    @Override
    public String toString()
    {
        return func_185359_l();
    }

    @Override
    @Nonnull
    public BiomeDecorator func_76729_a()
    {
        // todo: Forge event wrap this
        return new BiomeDecoratorTFC(lilyPadPerChunk, waterPlantsPerChunk);
    }

    public Biome setSpawnBiome()
    {
        spawnBiome = true;
        return this;
    }

    @Override
    public boolean func_185352_i()
    {
        return spawnBiome;
    }
}
